MsWrdStruct::Paragraph Struct Reference documentation

MsWrdStruct::Paragraph Struct Referencefinal

the paragraph structure of a Microsoft Word file More...

`#include <MsWrdStruct.hxx>`

Inheritance diagram for MsWrdStruct::Paragraph:

## Public Member Functions
| Paragraph (int version)
| Constructor.
| Paragraph (Paragraph const &)=default
Paragraph & | operator= (Paragraph const &)=default
Paragraph & | operator= (Paragraph &&)=default
| ~Paragraph () final
| destructor
void | insert (Paragraph const &para, bool insertModif=true)
| insert the new values
bool | read (MWAWInputStreamPtr &input, long endPos)
| try to read a data
void | updateParagraphToFinalState (Paragraph const *style=nullptr)
| update the paragraph to obtain the final paragraph
bool | getFont (Font &font, Font const *styleFont=nullptr) const
| returns the font which correspond to the paragraph if possible
bool | inTable () const
| returns true if we are in table
void | print (std::ostream &o, MWAWFontConverterPtr converter) const
| operator<<
int | getNumLines () const
| returns the number of line stored in m_info or -1
Public Member Functions inherited from MWAWParagraph
| MWAWParagraph ()
| constructor
| MWAWParagraph (MWAWParagraph const &)=default
MWAWParagraph & | operator= (MWAWParagraph const &)=default
MWAWParagraph & | operator= (MWAWParagraph &&)=default
virtual | ~MWAWParagraph ()
| destructor
bool | operator== (MWAWParagraph const &p) const
| operator==
bool | operator!= (MWAWParagraph const &p) const
| operator!=
int | cmp (MWAWParagraph const &p) const
| a comparison function
double | getMarginsWidth () const
| return the paragraph margin width (in inches)
bool | hasBorders () const
| check if the paragraph has some borders
bool | hasDifferentBorders () const
| check if the paragraph has different borders
void | resizeBorders (size_t newSize)
| a function used to resize the borders list ( adding empty borders if needed )
void | setInterline (double value, librevenge::RVNGUnit unit, LineSpacingType type=Fixed)
| set the interline
void | addTo (librevenge::RVNGPropertyList &propList, bool inTable) const
| add to the propList
void | insert (MWAWParagraph const &para)
| insert the set values of para in the actual paragraph

## Public Attributes
int | m_version
| the file version
MWAWVariable< int > | m_styleId
| the style id (if known)
MWAWVariable< double > | m_interline
| the interline if set
std::vector< float > | m_deletedTabs
| the delete tabulation
MWAWVariable< ParagraphInfo > | m_info
| the dimension
MWAWVariable< Font > | m_font
| the font
MWAWVariable< Font > | m_modFont
| font (modifier)
MWAWVariable< Section > | m_section
| the section
MWAWVariable< MWAWBorder > | m_bordersStyle
| the border style ( old v3)
MWAWVariable< bool > | m_inCell
| a cell/textbox
MWAWVariable< bool > | m_tableDef
| a table flag
MWAWVariable< Table > | m_table
| the table
Public Attributes inherited from MWAWParagraph
MWAWVariable< double > | m_margins [3]
| the margins
MWAWVariable< librevenge::RVNGUnit > | m_marginsUnit
| the margins INCH, ...
MWAWVariable< double > | m_spacings [3]
| the line spacing
MWAWVariable< librevenge::RVNGUnit > | m_spacingsInterlineUnit
| the interline unit PERCENT or INCH, ...
MWAWVariable< LineSpacingType > | m_spacingsInterlineType
| the interline type: fixed, atLeast, ...
MWAWVariable< std::vector< MWAWTabStop > > | m_tabs
| the tabulations
MWAWVariable< bool > | m_tabsRelativeToLeftMargin
| true if the tabs are relative to left margin, false if there are relative to the page margin (default)
MWAWVariable< Justification > | m_justify
| the justification
MWAWVariable< int > | m_breakStatus
| a list of bits: 0x1 (unbreakable), 0x2 (do not break after)
MWAWVariable< libmwaw::WritingMode > | m_writingMode
| the writing mode
MWAWVariable< int > | m_listLevelIndex
| the actual level index
MWAWVariable< int > | m_listId
| the list id (if know )
MWAWVariable< int > | m_listStartValue
| the list start value (if set )
MWAWVariable< MWAWListLevel > | m_listLevel
| the actual level
MWAWVariable< MWAWColor > | m_backgroundColor
| the background color
std::vector< MWAWVariable< MWAWBorder > > | m_borders
| list of border ( order MWAWBorder::Pos)
MWAWVariable< int > | m_dropNumCharacters
| the drop number character
MWAWVariable< int > | m_dropNumLines
| the drop number of lines
std::string | m_styleName
| the style name
std::string | m_extra
| a string to store some errors

## Friends
std::ostream & | operator<< (std::ostream &o, Paragraph const &ind)
| operator<<

## Additional Inherited Members
Public Types inherited from MWAWParagraph
enum | { NoBreakBit = 0x1 , NoBreakWithNextBit =0x2 }
| some bit use to defined the break status More...
enum | Justification { JustificationLeft , JustificationFull , JustificationCenter , JustificationRight , JustificationFullAllLines }
| an enum used to defined the paragraph justification: left, center, right, full ... More...
enum | LineSpacingType { Fixed , AtLeast }
| the line spacing type: fixed or at least More...

## Detailed Description

the paragraph structure of a Microsoft Word file

## Constructor & Destructor Documentation

## ◆ Paragraph() [1/2]

MsWrdStruct::Paragraph::Paragraph | ( | int | version | ) |
| inlineexplicit

Constructor.

Referenced by insert(), operator<<, operator=(), operator=(), Paragraph(), and updateParagraphToFinalState().

## ◆ Paragraph() [2/2]

MsWrdStruct::Paragraph::Paragraph | ( | Paragraph const & |  | ) |
| default

## ◆ ~Paragraph()

MsWrdStruct::Paragraph::~Paragraph | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ getFont()

bool MsWrdStruct::Paragraph::getFont | ( | Font & | font,
|  | Font const * | styleFont = nullptr ) const

returns the font which correspond to the paragraph if possible

Referenced by operator=(), and MsWrdText::prepareFontProperties().

## ◆ getNumLines()

int MsWrdStruct::Paragraph::getNumLines | ( |  | ) | const
| inline

returns the number of line stored in m_info or -1

## ◆ insert()

void MsWrdStruct::Paragraph::insert | ( | Paragraph const & | para,
|  | bool | insertModif = true )

insert the new values

Referenced by operator=(), MsWrdText::prepareParagraphProperties(), and MsWrdText::prepareTableLimits().

## ◆ inTable()

bool MsWrdStruct::Paragraph::inTable | ( |  | ) | const
| inline

returns true if we are in table

Referenced by inTable(), and MsWrdText::prepareParagraphProperties().

## ◆ operator=() [1/2]

Paragraph & MsWrdStruct::Paragraph::operator= | ( | Paragraph && |  | ) |
| default

## ◆ operator=() [2/2]

Paragraph & MsWrdStruct::Paragraph::operator= | ( | Paragraph const & |  | ) |
| default

## ◆ print()

void MsWrdStruct::Paragraph::print | ( | std::ostream & | o,
|  | MWAWFontConverterPtr | converter ) const

operator<<

Referenced by MsWrdText::prepareData(), MsWrdTextStyles::readPLC(), MsWrdTextStyles::readPropertyModifier(), MsWrdTextStyles::readStylesParagraph(), and MsWrdTextStyles::readTextStructList().

## ◆ read()

bool MsWrdStruct::Paragraph::read | ( | MWAWInputStreamPtr & | input,
|  | long | endPos )

try to read a data

Referenced by operator=(), and MsWrdTextStyles::readParagraph().

## ◆ updateParagraphToFinalState()

void MsWrdStruct::Paragraph::updateParagraphToFinalState | ( | Paragraph const * | style = nullptr | ) |

update the paragraph to obtain the final paragraph

Referenced by operator=(), and MsWrdText::prepareParagraphProperties().

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | Paragraph const & | ind )
| friend

operator<<

## Member Data Documentation

## ◆ m_bordersStyle

MWAWVariable<MWAWBorder> MsWrdStruct::Paragraph::m_bordersStyle

the border style ( old v3)

Referenced by insert(), operator<<, Paragraph(), and read().

## ◆ m_deletedTabs

std::vector<float> MsWrdStruct::Paragraph::m_deletedTabs

the delete tabulation

Referenced by insert(), operator<<, Paragraph(), and read().

## ◆ m_font

MWAWVariable<Font> MsWrdStruct::Paragraph::m_font

the font

Referenced by getFont(), MsWrdTextStyles::getSectionFont(), insert(), Paragraph(), print(), MsWrdTextStyles::readParagraph(), and MsWrdTextStyles::readStylesParagraph().

## ◆ m_inCell

MWAWVariable<bool> MsWrdStruct::Paragraph::m_inCell

a cell/textbox

Referenced by insert(), inTable(), operator<<, Paragraph(), and read().

## ◆ m_info

MWAWVariable<ParagraphInfo> MsWrdStruct::Paragraph::m_info

the dimension

Referenced by getNumLines(), insert(), operator<<, Paragraph(), and MsWrdTextStyles::readPLC().

## ◆ m_interline

MWAWVariable<double> MsWrdStruct::Paragraph::m_interline

the interline if set

Referenced by insert(), operator<<, Paragraph(), read(), and updateParagraphToFinalState().

## ◆ m_modFont

MWAWVariable<Font> MsWrdStruct::Paragraph::m_modFont

font (modifier)

Referenced by getFont(), insert(), Paragraph(), print(), MsWrdTextStyles::readParagraph(), and MsWrdTextStyles::readStylesParagraph().

## ◆ m_section

MWAWVariable<Section> MsWrdStruct::Paragraph::m_section

the section

Referenced by insert(), operator<<, Paragraph(), read(), and MsWrdTextStyles::sendSection().

## ◆ m_styleId

MWAWVariable<int> MsWrdStruct::Paragraph::m_styleId

the style id (if known)

Referenced by insert(), operator<<, Paragraph(), MsWrdText::prepareParagraphProperties(), MsWrdText::prepareTableLimits(), read(), and MsWrdTextStyles::readPLC().

## ◆ m_table

MWAWVariable<Table> MsWrdStruct::Paragraph::m_table

the table

Referenced by insert(), operator<<, Paragraph(), MsWrdText::prepareTableLimits(), and read().

## ◆ m_tableDef

MWAWVariable<bool> MsWrdStruct::Paragraph::m_tableDef

a table flag

Referenced by insert(), operator<<, Paragraph(), MsWrdText::prepareTableLimits(), and read().

## ◆ m_version

int MsWrdStruct::Paragraph::m_version

the file version

Referenced by Paragraph(), and read().

The documentation for this struct was generated from the following files:

- MsWrdStruct.hxx
- MsWrdStruct.cxx